<?php
if (!defined('_PS_VERSION_')){
  exit;
 } 

  class whatsappshare  extends Module
  
  { 
  
  public function __construct()
  {
    $this->name = 'whatsappshare';
    $this->tab = 'front_office_features';
    $this->version = '1.0.0';
    $this->author = 'NdiagaSoft';
    $this->need_instance = 0;
    $this->ps_versions_compliancy = array('min' => '1.5', 'max' =>_PS_VERSION_);
    $this->bootstrap = true;
 
    parent::__construct();
 
    $this->displayName = $this->l('WhatsApp Share Button');
    $this->description = $this->l('Allow Customers to Share your Content on WhatsApp.');
 
    $this->confirmUninstall = $this->l('Are you sure you want to uninstall?'); 
    
  }
  
  
  
  public function install()
{
  if (Shop::isFeatureActive())
    Shop::setContext(Shop::CONTEXT_ALL);
 
  if (!parent::install() ||    
	!$this->registerHook('productfooter')||		
    !$this->registerHook('header')||    
    !Configuration::updateValue('whatsappshare_INFO_TEXT','Share via Whatsapp') 	
  )
    return false;
 
  return true;
}
       public function uninstall()
    {       
		
		if (!parent::uninstall()||		    
            !Configuration::deleteByName('whatsappshare_INFO_TEXT')			
           )
                return false;
           
           return true;
    }	
  
  
        public function getContent()
    {
          $output = null;  		 
		  
		    if (Tools::isSubmit('submit'.$this->name))
      {
        $my_module_name =strval(Tools::getValue('whatsappshare_INFO_TEXT'));
		
        if (!$my_module_name || empty($my_module_name) || !Validate::isGenericName($my_module_name))
            $output .= $this->displayError($this->l('Invalid Configuration value'));
        else
        {
            Configuration::updateValue('whatsappshare_INFO_TEXT', $my_module_name);
			
			
			
		
            $output.= $this->displayConfirmation($this->l('Settings updated'));
        }
      }  		  

		   $output.=$this->displayForm().'</br>'.$this->InnovativesLabs();
       	
            return $output;
    }  
	
	
	public function hookProductFooter($params)
	{    
	    $html='';
		$id_product = (int)$params['product']->id;
		$product = $params['product'];
		$html.='Name:'.$product->name.'<br/>'.'Price:'.$product->price;
		
	$this->context->smarty->assign(
      array(	      
		  'intro_text'=>Configuration::get('whatsappshare_INFO_TEXT'), 
          'html'=>$html,		  
          'product'=>$product   		  
          
            )
             );  	  
	  
         
      return $this->display(__FILE__, 'whatsappshare.tpl');
		 
		
	}
   
    
    public function hookDisplayHeader()
   {
        $this->context->controller->addCSS(($this->_path).'css/whatsappshare.css', 'all');
    }    
   

  	   public function displayForm()
   {
    // Get default language
    $default_lang = (int)Configuration::get('PS_LANG_DEFAULT');
     
    // Init Fields form array
    $fields_form[0]['form'] = array(
        'legend' => array(
            'title' => $this->l('Settings'),
			'icon' => 'icon-cogs'
        ),
        'input' => array(
            array(
                'type' => 'text',
                'label' => $this->l('Informative Text:'),
                'name' => 'whatsappshare_INFO_TEXT',
                'size' => 20,
				'desc' => $this->l('Add the message to communicate to the customer.'),
                'required' => true
            ),
					
			
        ),
		
		
        'submit' => array(
            'title' => $this->l('Save'),           
        )
    );
     
    $helper = new HelperForm();
     
    // Module, token and currentIndex
    $helper->module = $this;
    $helper->name_controller = $this->name;
    $helper->token = Tools::getAdminTokenLite('AdminModules');
    $helper->currentIndex = AdminController::$currentIndex.'&configure='.$this->name;
     
    // Language
    $helper->default_form_language = $default_lang;
    $helper->allow_employee_form_lang = $default_lang;
     
    // Title and toolbar
    $helper->title = $this->displayName;
    $helper->show_toolbar = true;        // false -> remove toolbar
    $helper->toolbar_scroll = true;      // yes - > Toolbar is always visible on the top of the screen.
    $helper->submit_action = 'submit'.$this->name;
    $helper->toolbar_btn = array(
        'save' =>
        array(
            'desc' => $this->l('Save'),
            'href' => AdminController::$currentIndex.'&configure='.$this->name.'&save'.$this->name.
            '&token='.Tools::getAdminTokenLite('AdminModules'),
        ),
        'back' => array(
            'href' => AdminController::$currentIndex.'&token='.Tools::getAdminTokenLite('AdminModules'),
            'desc' => $this->l('Back to list')
        )
    );
     
    // Load current value
    $helper->fields_value['whatsappshare_INFO_TEXT'] = Configuration::get('whatsappshare_INFO_TEXT');
    
	
	 
    return $helper->generateForm($fields_form);
    }   

  
  public function innovativesLabs(){
  
  return $this->display(__FILE__, 'innovativeslabs.tpl');
  
  }  
  

  
  
  }

